﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PermutationAlgorithms.PermAlgorithms.Impl
{
    /// <summary>
    /// Backtracking algorithm (recursive).
    /// Reference: https://www.cs.princeton.edu/~rs/talks/perms.pdf
    /// </summary>
    class BackTrackRecursive : AbstractPermAlgo
    {
        public BackTrackRecursive(int numOfItems, IPermutationVisitor permVisitor) :
            base(numOfItems, permVisitor) { }

        public override void Generate()
        {
            GenerateIntern(this.ItemCount);
        }

        private void GenerateIntern(int n)
        {
            if (n == 1)
            {
                VisitPermutation();
            }
            else
            {
                for (int c = 0; c < n - 1; c++)
                {
                    Swap(ref items[c], ref items[n - 1]);

                    GenerateIntern(n - 1);

                    Swap(ref items[c], ref items[n - 1]);
                }

                GenerateIntern(n - 1);
            }
        }
    }
}
