﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PermutationAlgorithms.PermAlgorithms.Impl
{
    class BackTrackRecursiveExchangeReversed : AbstractPermAlgo
    {
        public BackTrackRecursiveExchangeReversed(int numOfItems, IPermutationVisitor permVisitor) :
            base(numOfItems, permVisitor) { }

        public override void Generate()
        {
            GenerateIntern(this.ItemCount);
        }

        private void GenerateIntern(int n)
        {
            if (n == 1)
            {
                VisitPermutation();
            }
            else
            {
                for (int c = this.ItemCount - 1; c > this.ItemCount - n; c--)
                {
                    Swap(ref items[c], ref items[this.ItemCount - n]);

                    GenerateIntern(n - 1);

                    Swap(ref items[c], ref items[this.ItemCount - n]);
                }

                GenerateIntern(n - 1);
            }
        }
    }
}
