﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PermutationAlgorithms.PermAlgorithms.Impl
{
    /// <summary>
    /// Permutation generation methods
    /// Robert Sedgewickhttps://www.cs.princeton.edu/~rs/talks/perms.pdf
    /// </summary>
    class HeapIterative : AbstractPermAlgo
    {
        public HeapIterative(int numOfItems, IPermutationVisitor permVisitor) :
            base(numOfItems, permVisitor) { }

        public override void Generate()
        {
            int[] c = new int[ItemCount];

            for (int i = 0; i < ItemCount; i++)
            {
                c[i] = 0;
            }

            VisitPermutation();

            for (int i = 0; i < ItemCount; )
            {
                if (c[i] < i)
                {
                    if ( (i % 2) == 0)
                    {
                        Swap(ref items[0], ref items[i]);
                    }
                    else
                    {
                        Swap(ref items[c[i]], ref items[i]);
                    }
                    VisitPermutation();
                    c[i]++;
                    i = 0;
                }
                else
                {
                    c[i] = 0;
                    i++;
                }
            }
        }
    }
}
