﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PermutationAlgorithms.PermAlgorithms.Impl
{
    /// <summary>
    /// Permutation generation methods
    /// Robert Sedgewickhttps://www.cs.princeton.edu/~rs/talks/perms.pdf
    /// </summary>
    class HeapRecursive : AbstractPermAlgo
    {
        public HeapRecursive(int numOfItems, IPermutationVisitor permVisitor) :
            base(numOfItems, permVisitor) { }

        public override void Generate()
        {
            GenerateIntern(ItemCount);
        }

        private void GenerateIntern(int n)
        {
            if (n == 1)
            {
                VisitPermutation();
            }
            else
            {
                for (int i = 0; i < n - 1; i++)
                {
                    GenerateIntern(n - 1);
                    if ((n % 2) == 0)
                    {
                        Swap(ref items[i], ref items[n - 1]);
                    }
                    else
                    {
                        Swap(ref items[0], ref items[n - 1]);
                    }
                }
                GenerateIntern(n - 1);
            }
        }
    }
}
