﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PermutationAlgorithms.PermAlgorithms.Impl
{
    /// <summary>
    /// Counting And Listing All Permutations - Alexander Bogomolny
    /// www.cut-the-knot.org/do_you_know/AllPerm.shtml
    /// </summary>
    class KLevelRecursive : AbstractPermAlgo
    {
        private readonly char PlaceholderItem = (char)(StartItem - 1);

        public KLevelRecursive(int numOfItems, IPermutationVisitor permVisitor) :
            base(numOfItems, permVisitor) { }

        public override void Generate()
        {
            for (int i = 0; i < ItemCount; i++)
            {
                items[i] = PlaceholderItem;
            }

            Generate(0, -1, 0, 0);
        }

        private void Generate(int k, int level, int i, int index)
        {
            int levelUsed = level;

            levelUsed = levelUsed + 1;
            items[k] = (char)(PlaceholderItem + levelUsed);

            if (levelUsed == ItemCount)
            {
                VisitPermutation();
            }
            else
            {
                for (index = 0; index < ItemCount; index++)
                    if (items[index] == PlaceholderItem)
                        Generate(index, levelUsed, i, index);
            }

            items[k] = PlaceholderItem;
        }
    }
}
